/**
 * Drag n resize global variables.
 */
var vidlock_dx = vidlock_dy = 0;
var vidlock_el_previous_width = vidlock_el_previous_height = 0;
var vidlock_tx = vidlock_ty = vidlock_diff = 0;
var resize_from;

/**
 * Other functions
 */
var vidlock_get_id = function(full_id)
{
	var full_id_split = full_id.split('vidlock-element-');
	return full_id_split[1];
};
var get_vidlock_container_pos = function()
{
	var container = jQuery('#VidLocker-popup-builder-container').offset();
	return {x: container.left, y: container.top};
};
var is_valid_url = function(str)
{
	var urlregex = new RegExp("^(http|https|ftp)\://([a-zA-Z0-9\.\-]+(\:[a-zA-Z0-9\.&amp;%\jQuery\-]+)*@)*((25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])|([a-zA-Z0-9\-]+\.)*[a-zA-Z0-9\-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(\:[0-9]+)*(/(jQuery|[a-zA-Z0-9\.\,\?\'\\\+&amp;%\jQuery#\=~_\-]+))*jQuery");
	return true;//urlregex.test(str);
};
var show_container_flow = function()
{
	/*
	var container = jQuery('#VidLocker-popup-builder-container');
	jQuery('#VidLocker-popup-builder-flow').css({
		width: container.width(),
		height: container.height(),
		top: container.offset().top,
		left: container.offset().left
	}).show();
	*/
};
var getMousePosition = function(e)
{
    if (e.pageX || e.pageY)
    {
        var posx = e.pageX;
        var posy = e.pageY;
    }
    else if (e.clientX || e.clientY)
    {
        var posx = e.clientX
        var posy = e.clientY
    }
    return {x: posx, y: posy};
};
var fix_pop_container_position = function()
{
	var wrap_offset = jQuery('.wrap').offset();
	// var pop_top = (jQuery(window).height()/2) - (jQuery('#VidLocker-popup-builder-container').height()/2) - wrap_offset.top;
	var pop_left = (jQuery(window).width()/2) - (jQuery('#VidLocker-popup-builder-container').width()/2) ;
	if (jQuery(window).width() < (jQuery('#VidLocker-popup-builder-container').width() + jQuery('.VidLocker-box').width() + 40))
	{
		pop_left = jQuery('.VidLocker-box').width() + 20;
	}
	jQuery('#VidLocker-popup-builder-container').css({ 'left': pop_left});
};
var fix_element_position_onselect_onmove = function(el)
{
	el.css({'top': el.css('top').replace('px', '') - 2, 'left': el.css('left').replace('px', '') - 2});
};
var fix_element_position_ondeselect_onmouseleave = function(el)
{
	el.css({'top': el.css('top').replace('px', '') + 2, 'left': el.css('left').replace('px', '') + 2});
};
var get_youtube_video_id = function(url)
{
	// old function
	var videoid = url.match(/(?:https?:\/{2})?(?:w{3}\.)?youtu(?:be)?\.(?:com|be)(?:\/watch\?v=|\/)([^\s&]+)/);
	if(videoid != null)
	{
	   return videoid[1];
	}
	else
	{ 
		return 'null';
	}
};
var YouTubeGetID = function(url)
{
	var regExp = /^.*((youtu.be\/)|(v\/)|(\/u\/\w\/)|(embed\/)|(watch\?))\??v?=?([^#\&\?]*).*/;
	var match = url.match(regExp);
	if (match && match[7].length == 11)
	{
	    return match[7];
	}
	else
	{
	    return '';
	}
};
var htmlspecialchars_js = function(text)
{
	return text
		.replace(/&/g, "&VidLocker_amp;")
		.replace(/</g, "&VidLocker_lt;")
		.replace(/>/g, "&VidLocker_gt;")
		.replace(/"/g, "&VidLocker_quot;")
		.replace(/'/g, "&#VidLocker_039;");
};
var blur_on_enter = function(event, element)
{
	var key = event.keyCode || event.which;
	if (key == 13)
	{
		element.blur();
	}
};

/**
 * Elements and objects functions
 */
// add element callback
var vidlock_add_element_to_container = function(element, select_me)
{
	// detect more form fields
	if (element.type == 'form_field')
	{
		var form_fields_count = 0;
		for (i = 0; i < vidlock_elements.length; i++)
		{
			if (vidlock_elements[i].type == 'form_field')
				form_fields_count++;
		}
		if (form_fields_count >= 2)
		{
			alert('You can\'t add more than 2 form fields!');
			return;
		}
	}

	// add element's object to objects array
	vidlock_elements.push(element);
	el_auto_inc_id++;

	// vars
	var el_id = element.id;
	var el_full_id = 'vidlock-element-' + el_id;
	var do_editor = false;
	var background = '';

	// element type
	var el_sub_html;
	if (element.type == 'text')
	{
		do_editor = true;
		background = element.background;
		el_sub_html = '<textarea id="editor' + el_id + '" name="editor" placeholder="Type your text here...">' + element.html + '</textarea>';
	}
	else if (element.type == 'image')
	{
		el_sub_html = '<img src="' + element.img_src + '" width="100%" height="100%" alt="" />';
	}
	else if (element.type == 'countdown')
	{
		el_sub_html = '<img src="' + counter_image_src + '" width="100%" height="100%" alt="" />';
	}
	else if (element.type == 'cta_button')
	{
		el_sub_html = '<div class="vidlock-element-cta-button"><table style="width: 100%; height: 100%; border: 0; padding 0; margin: 0;"><tr><td valign="middle">' + element.cta_text + '</td></tr></table></div>';
	}
	else if (element.type == 'form_field')
	{
		el_sub_html = '<div class="vidlock-element-field-container"><input type="text" placeholder="' + element.placeholder + '" /></div>';
	}
	else if (element.type == 'youtube_video')
	{
		var video_thumb;
		if (element.video_id == '')
		{
			video_thumb = default_youtube_video_thumbnail;
		}
		else
		{
			video_thumb = 'http://img.youtube.com/vi/' + element.video_id + '/mqdefault.jpg';
		}
		el_sub_html = '<div class="vidlock-element-youtube-video-container"><img class="vidlock-element-youtube-play" src="' + icon_youtubeplay + '" width="60" alt="0" /><img class="vidlock-element-youtube-thumbnail" src="' + video_thumb + '" width="100%" height="100%" alt="" /></div>';
	}
	else if (element.type == 'html_code')
	{
		el_sub_html = '<div style="width: 100%; height: 100%; position: absolute; top: 0; left: 0;"></div><div class="html_code">' + element.html_code + '</div>';
	}

	var el_html = '<div id="' + el_full_id + '" class="vidlock-drag-resize-item" style="background: ' + background + ';">'
				+ '    <div class="vidlock-element-content">'
				+ '        ' + el_sub_html
				+ '    </div>'
				+ '    <div class="vidlock-drag-handle"></div>'
				+ '    <div class="vidlock-resize-handle vidlock-resize-handle-top"></div>'
				+ '    <div class="vidlock-resize-handle vidlock-resize-handle-right"></div>'
				+ '    <div class="vidlock-resize-handle vidlock-resize-handle-bottom"></div>'
				+ '    <div class="vidlock-resize-handle vidlock-resize-handle-left"></div>'
				+ '</div>';
	jQuery('#VidLocker-popup-builder-container').append(el_html);
	jQuery('#' + el_full_id).css({
		'z-index': element.zindex,
		left: element.x,
		top: element.y,
		width: element.width,
		height: element.height
	});
	// apply style to elements
	if (element.type == 'text')
	{
		jQuery('#' + el_full_id).css('backgroundColor', element.background);
	}
	else if (element.type == 'image')
	{
		// nothing to do for the image
	}
	else if (element.type == 'cta_button')
	{
		jQuery('#' + el_full_id + ' .vidlock-element-cta-button').css({
			'background-color': element.background,
			'border-width': element.border_size,
			'border-style': 'solid',
			'border-color': element.border_color,
			'color': element.color,
			'font-weight': element.font_weight,
			'font-size': element.font_size + 'pt',
			'-moz-border-radius-topleft': element.border_top_left_corner + 'px', '-webkit-border-top-left-radius': element.border_top_left_corner + 'px', 'border-top-left-radius': element.border_top_left_corner + 'px',
			'-moz-border-radius-topright': element.border_top_right_corner + 'px', '-webkit-border-top-right-radius': element.border_top_right_corner + 'px', 'border-top-right-radius': element.border_top_right_corner + 'px',
			'-moz-border-radius-bottomleft': element.border_bottom_left_corner + 'px', '-webkit-border-bottom-left-radius': element.border_bottom_left_corner + 'px', 'border-bottom-left-radius': element.border_bottom_left_corner + 'px',
			'-moz-border-radius-bottomright': element.border_bottom_right_corner + 'px', '-webkit-border-bottom-right-radius': element.border_bottom_right_corner + 'px', 'border-bottom-right-radius': element.border_bottom_right_corner + 'px'
		});
	}
	else if (element.type == 'form_field')
	{
		jQuery('#' + el_full_id + ' .vidlock-element-field-container').css({
			'border-width': element.border_size,
			'border-style': 'solid',
			'border-color': element.border_color,
			'-moz-border-radius-topleft': element.border_top_left_corner + 'px', '-webkit-border-top-left-radius': element.border_top_left_corner + 'px', 'border-top-left-radius': element.border_top_left_corner + 'px',
			'-moz-border-radius-topright': element.border_top_right_corner + 'px', '-webkit-border-top-right-radius': element.border_top_right_corner + 'px', 'border-top-right-radius': element.border_top_right_corner + 'px',
			'-moz-border-radius-bottomleft': element.border_bottom_left_corner + 'px', '-webkit-border-bottom-left-radius': element.border_bottom_left_corner + 'px', 'border-bottom-left-radius': element.border_bottom_left_corner + 'px',
			'-moz-border-radius-bottomright': element.border_bottom_right_corner + 'px', '-webkit-border-bottom-right-radius': element.border_bottom_right_corner + 'px', 'border-bottom-right-radius': element.border_bottom_right_corner + 'px'
		});
	}
	else if (element.type == 'youtube_video')
	{
		// nothing to do for the youtube video
	}
	else if (element.type == 'html_code')
	{
		// nothing to do for the html code
	}

	// other
	if (select_me)
	{
		select_element(jQuery('#' + el_full_id), false);
	}
	if (do_editor)
	{
		doEditor('#editor' + el_id);
	}
};
// select element
var select_element = function(el, slide_up)
{
	var el_id = vidlock_get_id(el.attr('id'));
	if (selected_el_id == el_id)
	{
		console.log('Element #' + el_id + ' is already selected.');
		return;
	}
	selected_el_id = el_id;
	// outline item content
	jQuery('.vidlock-element-content').removeClass('vidlock-selected')
	jQuery('.vidlock-element-content').removeClass('vidlock-mousemove');
	jQuery('.vidlock-topelement').removeClass('vidlock-topelement');
	// 
	jQuery('.vidlock-drag-handle, .vidlock-resize-handle').hide();
	el.find('.vidlock-drag-handle, .vidlock-resize-handle').show();
	setTimeout(function(){
		el.find('.vidlock-element-content').addClass('vidlock-selected');
		el.addClass('vidlock-topelement');

	}, 200);
	// element options
	jQuery('#no-selected-element').hide();
	show_element_options(el_id);
	// make handlers on the top
	jQuery('.vidlock-drag-resize-item').find('.vidlock-drag-handle, .vidlock-resize-handle').css('z-index', 0);
	el.find('.vidlock-drag-handle, .vidlock-resize-handle').css('z-index', 1000);
	// slide up 
	if (slide_up)
	{
		jQuery('.box-title-pop-elements .box-toggle').css('background-position', 'bottom');
		// jQuery('#box-elements-box-content').slideUp();
	}

	console.log('Element #' + el_id + ' selected.');
}
// get element's object
var get_VidLocker_element_object = function(el_id)
{
	var el = null;
	for (i = 0; i < vidlock_elements.length; i++)
	{
		var el_this = vidlock_elements[i];
		if (el_this.id == el_id)
		{
			el = el_this;
			break;
		}
	}
	return el;
};
// update element's object
var update_VidLocker_element_object = function(object)
{
	for (i = 0; i < vidlock_elements.length; i++)
	{
		if (vidlock_elements[i].id == object.id)
		{
			vidlock_elements[i] = object;
			break;
		}
	}
};
// get element details
var get_VidLocker_element_details = function(el_id)
{
	var el = jQuery('#vidlock-element-' + el_id);
	return {x: el.css('left').replace('px', ''), y: el.css('top').replace('px', ''), width: el.width(), height: el.height()};
};
// 
var update_VidLocker_element_details = function(type, details)
{
	var parent_id = '';
	if (type == 'text')
	{
		parent_id = '#VidLocker-text-options';
	}
	else if (type == 'image')
	{
		parent_id = '#VidLocker-image-options';
	}
	else if (type == 'cta_button')
	{
		parent_id = '#VidLocker-cta-button-options';
	}
	else if (type == 'form_field')
	{
		parent_id = '#VidLocker-form-field-options';
	}
	else if (type == 'youtube_video')
	{
		parent_id = '#VidLocker-youtube-video-options';
	}
	else if (type == 'html_code')
	{
		parent_id = '#VidLocker-html-code-options';
	}
	else if (type == 'countdown')
	{
		parent_id = '#VidLocker-countdown-options';
	}
	jQuery(parent_id + ' .VidLocker-element-css-width').text(details.width);
	jQuery(parent_id + ' .VidLocker-element-css-height').text(details.height);
	jQuery(parent_id + ' .VidLocker-element-css-x').text(details.x);
	jQuery(parent_id + ' .VidLocker-element-css-y').text(details.y);
};
var show_element_options = function(el_id)
{
	var el_object = get_VidLocker_element_object(el_id);
	jQuery('.VidLocker-options').hide();
	if (el_object.type == 'text')
	{
		update_VidLocker_element_details('text', el_object);
		jQuery('#VidLocker-text-options .VidLocker-element-id').text(el_id);

		// ## Load text details
		// background
		jQuery('#VidLocker-text-background').val(el_object.background);
			jQuery('#cpctb-colorpicker div').css('background-color', el_object.background);
			jQuery('#cpctb-colorpicker').ColorPickerSetColor(el_object.background);
		// transparent background
		if (el_object.background == '')
		{
			jQuery('#VidLocker-text-background-transparent').attr('checked', true);
		}

		// then show options
		jQuery('#VidLocker-text-options').fadeIn(1200);
	}
	if (el_object.type == 'image')
	{
		update_VidLocker_element_details('image', el_object);
		jQuery('#VidLocker-image-options .VidLocker-element-id').text(el_id);

		// ## Load image details
		// image src
		jQuery('#VidLocker-image-img-url').val(el_object.img_src);
		// image url
		jQuery('#VidLocker-image-url').val(el_object.url);

		// then show options
		jQuery('#VidLocker-image-options').fadeIn(1200);
	}
	if (el_object.type == 'cta_button')
	{
		update_VidLocker_element_details('cta_button', el_object);
		jQuery('#VidLocker-cta-button-options .VidLocker-element-id').text(el_id);

		// ## Load cta button details
		// action
		jQuery('#VidLocker-cta-button-action').val('link');
		jQuery('#VidLocker-cta-button-url').parent().parent().hide();
		if (el_object.action == 'link')
		{
			jQuery('#VidLocker-cta-button-url').parent().parent().slideDown();
		}
		// url
		jQuery('#VidLocker-cta-button-url').val(el_object.url);
		// cta text
		jQuery('#VidLocker-cta-button-text').val(el_object.cta_text);
		// font size
		jQuery('#VidLocker-cta-button-font-size').val(el_object.font_size);
		// font weight
		jQuery('#VidLocker-cta-button-font-weight').val(el_object.font_weight);
		// color
		jQuery('#VidLocker-cta-button-color').val(el_object.color);
			jQuery('#cpccbc-colorpicker div').css('background-color', el_object.color);
			jQuery('#cpccbc-colorpicker').ColorPickerSetColor(el_object.color);
		// background color
		jQuery('#VidLocker-cta-button-color').val(el_object.color);
			jQuery('#cpccbb-colorpicker div').css('background-color', el_object.background);
			jQuery('#cpccbb-colorpicker').ColorPickerSetColor(el_object.background);
		// border size
		jQuery('#VidLocker-cta-button-border-size').val(el_object.border_size);
		// border color
		jQuery('#VidLocker-cta-button-border-color').val(el_object.border_color);
			jQuery('#cpccbbc-colorpicker div').css('background-color', el_object.border_color);
			jQuery('#cpccbbc-colorpicker').ColorPickerSetColor(el_object.border_color);
		// border radius
		jQuery('#VidLocker-cta-button-border-top-left').val(el_object.border_top_left_corner);
		jQuery('#VidLocker-cta-button-border-top-right').val(el_object.border_top_right_corner);
		jQuery('#VidLocker-cta-button-border-bottom-left').val(el_object.border_bottom_left_corner);
		jQuery('#VidLocker-cta-button-border-bottom-right').val(el_object.border_bottom_right_corner);

		// then show options
		jQuery('#VidLocker-cta-button-options').fadeIn(1200);
	}
	if (el_object.type == 'form_field')
	{
		update_VidLocker_element_details('form_field', el_object);
		jQuery('#VidLocker-form-field-options .VidLocker-element-id').text(el_id);

		// ## Load field details
		// is name or email
		var subscribe_type = (el_object.id == vidlock_popup_settings.name_field_id) ? 'name' : ((el_object.id == vidlock_popup_settings.email_field_id) ? 'email' : '');
		console.log("Field type: " + subscribe_type);
		jQuery('#VidLocker-form-field-subscribe-type').val(subscribe_type);
		// placeholder
		jQuery('#VidLocker-form-field-placeholder').val(el_object.placeholder);
		// font size
		jQuery('#VidLocker-form-field-font-size').val(el_object.font_size);
		// color
		jQuery('#VidLocker-form-field-color').val(el_object.color);
			jQuery('#cpcffc-colorpicker div').css('background-color', el_object.color);
			jQuery('#cpcffc-colorpicker').ColorPickerSetColor(el_object.color);
		// border size
		jQuery('#VidLocker-form-field-border-size').val(el_object.border_size);
		// border color
		jQuery('#VidLocker-form-field-border-color').val(el_object.border_color);
			jQuery('#cpcffbc-colorpicker div').css('background-color', el_object.border_color);
			jQuery('#cpcffbc-colorpicker').ColorPickerSetColor(el_object.border_color);
		// border radius
		jQuery('#VidLocker-form-field-border-top-left').val(el_object.border_top_left_corner);
		jQuery('#VidLocker-form-field-border-top-right').val(el_object.border_top_right_corner);
		jQuery('#VidLocker-form-field-border-bottom-left').val(el_object.border_bottom_left_corner);
		jQuery('#VidLocker-form-field-border-bottom-right').val(el_object.border_bottom_right_corner);

		// then show options
		jQuery('#VidLocker-form-field-options').fadeIn(1200);
	}
	if (el_object.type == 'youtube_video')
	{
		update_VidLocker_element_details('youtube_video', el_object);
		jQuery('#VidLocker-youtube-video-options .VidLocker-element-id').text(el_id);

		// ## Load youtube video details
		// video src
		jQuery('#VidLocker-youtube-video-url').val((el_object.video_id != '') ? 'http://youtube.com/watch?v=' + el_object.video_id : '');
		// video autoplay
		jQuery('#VidLocker-youtube-video-autoplay').val(el_object.autoplay);

		// then show options
		jQuery('#VidLocker-youtube-video-options').fadeIn(1200);
	}
	if (el_object.type == 'html_code')
	{
		update_VidLocker_element_details('html_code', el_object);
		jQuery('#VidLocker-html-code-options .VidLocker-element-id').text(el_id);

		// ## Load html code details
		// code
		jQuery('#VidLocker-html-code-code').val(el_object.html_code);

		// then show options
		jQuery('#VidLocker-html-code-options').fadeIn(1200);
	}
	if (el_object.type == 'countdown')
	{
		update_VidLocker_element_details('countdown', el_object);
		jQuery('#VidLocker-countdown-options .VidLocker-element-id').text(el_id);

		// ## Load html code details
		// code
		jQuery('#VidLocker-countdown-finish').val(el_object.finish);
		jQuery('#VidLocker-countdown-font').val(el_object.font);
		jQuery('#VidLocker-countdown-color').val(el_object.color);

		// then show options
		jQuery('#VidLocker-countdown-options').fadeIn(1200);
	}
};
var hide_element_options = function()
{
	var options_to_hide = null;
	jQuery('.VidLocker-options').each(function(i, obj){
		obj = jQuery(obj);
	    if (obj.is(':visible'))
	    {
	    	options_to_hide = obj;
	    }
	});
	if (options_to_hide != null)
	{
		jQuery(options_to_hide).fadeOut(600, function(){
			jQuery('#no-selected-element').show();
			console.log("options hide.");
		});
	}
};
var show_popup_options = function()
{
	jQuery('#no-selected-element').hide();
	jQuery('.VidLocker-options').hide(); // hide all options divs
	selected_el_id = 0; // deselect any element
	jQuery('.vidlock-drag-resize-item').removeClass('vidlock-selected').find('.vidlock-drag-handle, .vidlock-resize-handle').hide();

	// ## Load field details
	// width
	jQuery('#VidLocker-popup-width').val(vidlock_popup_settings.width);
	// height
	jQuery('#VidLocker-popup-height').val(vidlock_popup_settings.height);
	// border size
	jQuery('#VidLocker-popup-border-size').val(vidlock_popup_settings.border_size);
	// border color
	jQuery('#VidLocker-popup-border-color').val(vidlock_popup_settings.border_color);
		jQuery('#cpcpbc-colorpicker div').css('background-color', vidlock_popup_settings.border_color);
		jQuery('#cpcpbc-colorpicker').ColorPickerSetColor(vidlock_popup_settings.border_color);
	// border style
	jQuery('#VidLocker-popup-border-style').val(vidlock_popup_settings.border_style);
	// background image
	jQuery('#VidLocker-popup-bg-image-url').val(vidlock_popup_settings.background_url);
	// background color
	jQuery('#VidLocker-popup-border-color').val(vidlock_popup_settings.background);
		jQuery('#cpcpb-colorpicker div').css('background-color', vidlock_popup_settings.background);
		jQuery('#cpcpb-colorpicker').ColorPickerSetColor(vidlock_popup_settings.background);
	// transparent background
	if (vidlock_popup_settings.background == '')
	{
		jQuery('#VidLocker-popup-background-transparent').attr('checked', true);
	}
	// border radius
	jQuery('#VidLocker-popup-border-top-left').val(vidlock_popup_settings.border_top_left_corner);
	jQuery('#VidLocker-popup-border-top-right').val(vidlock_popup_settings.border_top_right_corner);
	jQuery('#VidLocker-popup-border-bottom-left').val(vidlock_popup_settings.border_bottom_left_corner);
	jQuery('#VidLocker-popup-border-bottom-right').val(vidlock_popup_settings.border_bottom_right_corner);

	// then show options
	jQuery('#VidLocker-popup-options').fadeIn(1200);
};

/**
 * cpcash all options - callbacks
 */
var VidLocker_topit = function(el_id)
{
	var el = jQuery('#vidlock-element-' + el_id);
	var zindex = vidlock_elements.length+1;
	update_element_object_zindex(el_id, zindex);
	el.css('z-index', zindex);
}
var VidLocker_deleteit = function(el_id)
{
	if (confirm('Are you sure that you want to delete this element?'))
	{
		hide_element_options();
		selected_el_id = null;
    	var el = jQuery('#vidlock-element-' + el_id);
    	var el_index = -1;
    	for (i = 0; i < vidlock_elements.length; i++)
    	{
    		var el_this = vidlock_elements[i];
    		if (el_this.id == el_id)
    		{
    			el_index = i;
    			break;
    		}
    	}
    	el.remove(); // remove dom element
    	if (el_id == vidlock_popup_settings.name_field_id)
    	{
    		vidlock_popup_settings.name_field_id = 0;
    	}
    	if (el_id == vidlock_popup_settings.email_field_id)
    	{
    		vidlock_popup_settings.email_field_id = 0;
    	}
    	vidlock_elements.splice(el_index, 1); // remove element's object
	}
}
var VidLocker_deselectit = function(el_id)
{
	if (selected_el_id == null)
		return;
	// deselect element
	// console.log("Element #" + selected_el_id + " deselected.")
	hide_element_options();
	selected_el_id = null;
	jQuery('.vidlock-element-content').removeClass('vidlock-selected');
	jQuery('.vidlock-drag-handle, .vidlock-resize-handle').hide();
}

/**
 * Update element functions
 */
// update x and y
var update_element_object_xy = function(el_id)
{
	var el = jQuery('#vidlock-element-' + el_id);
	var object = get_VidLocker_element_object(el_id);
	object.x = parseInt(el.css('left').replace('px', ''));
	object.y = parseInt(el.css('top').replace('px', ''));
	update_VidLocker_element_object(object);
};
// update width and height
var update_element_object_width_height = function(el_id)
{
	var el = jQuery('#vidlock-element-' + el_id);
	var object = get_VidLocker_element_object(el_id);
	object.width = parseInt(el.css('width').replace('px', ''));
	object.height = parseInt(el.css('height').replace('px', ''));
	update_VidLocker_element_object(object);
};
// update element zindex
var update_element_object_zindex = function(el_id, zindex)
{
	var object = get_VidLocker_element_object(el_id);
	object.zindex = zindex;
	update_VidLocker_element_object(object);
};
// update text background
var update_element_object_background = function(el_id, background)
{
	var object = get_VidLocker_element_object(el_id);
	object.background = background;
	update_VidLocker_element_object(object);
};
// update text html
var update_element_html = function(el_id, html)
{
	var object = get_VidLocker_element_object(el_id);
	object.html = html;
	update_VidLocker_element_object(object);
};
// update image src
var update_element_object_img_src = function(el_id, img_src)
{
	var object = get_VidLocker_element_object(el_id);
	object.img_src = img_src;
	update_VidLocker_element_object(object);
};
// update image url - on click
var update_element_object_img_url = function(el_id, url)
{
	var object = get_VidLocker_element_object(el_id);
	object.url = url;
	update_VidLocker_element_object(object);
};
// update cta button action type
var update_element_object_cta_action = function(el_id, action)
{
	var object = get_VidLocker_element_object(el_id);
	object.action = action;
	update_VidLocker_element_object(object);
};
// update cta button url - on click
var update_element_object_cta_url = function(el_id, url)
{
	var object = get_VidLocker_element_object(el_id);
	object.url = url;
	update_VidLocker_element_object(object);
};
// update cta button text
var update_element_object_text = function(el_id, text)
{
	var object = get_VidLocker_element_object(el_id);
	object.cta_text = text;
	update_VidLocker_element_object(object);
};
// update cta button font weight
var update_element_object_font_weight = function(el_id, font_weight)
{
	var object = get_VidLocker_element_object(el_id);
	object.font_weight = font_weight;
	update_VidLocker_element_object(object);
};
// update form field placeholder
var update_element_object_placeholder = function(el_id, placeholder)
{
	var object = get_VidLocker_element_object(el_id);
	object.placeholder = placeholder;
	update_VidLocker_element_object(object);
};
// update form field font size
var update_element_object_font_size = function(el_id, font_size)
{
	var object = get_VidLocker_element_object(el_id);
	object.font_size = font_size;
	update_VidLocker_element_object(object);
};
// update form field color
var update_element_object_color = function(el_id, color)
{
	var object = get_VidLocker_element_object(el_id);
	object.color = color;
	update_VidLocker_element_object(object);
};
// update form field border size
var update_element_object_border_size = function(el_id, border_size)
{
	var object = get_VidLocker_element_object(el_id);
	object.border_size = border_size;
	update_VidLocker_element_object(object);
};
// update form field border color
var update_element_object_border_color = function(el_id, border_color)
{
	var object = get_VidLocker_element_object(el_id);
	object.border_color = border_color;
	update_VidLocker_element_object(object);
};
// update form field border radius top left
var update_element_object_border_tlc = function(el_id, border_tlc)
{
	var object = get_VidLocker_element_object(el_id);
	object.border_top_left_corner = border_tlc;
	update_VidLocker_element_object(object);
};
// update form field border radius top right
var update_element_object_border_trc = function(el_id, border_trc)
{
	var object = get_VidLocker_element_object(el_id);
	object.border_top_right_corner = border_trc;
	update_VidLocker_element_object(object);
};
// update form field border radius bottom left
var update_element_object_border_blc = function(el_id, border_blc)
{
	var object = get_VidLocker_element_object(el_id);
	object.border_bottom_left_corner = border_blc;
	update_VidLocker_element_object(object);
};
// update form field border radius bottom right
var update_element_object_border_brc = function(el_id, border_brc)
{
	var object = get_VidLocker_element_object(el_id);
	object.border_bottom_right_corner = border_brc;
	update_VidLocker_element_object(object);
};
// update youtube video id
var update_element_object_youtube_video_id = function(el_id, video_id)
{
	var object = get_VidLocker_element_object(el_id);
	object.video_id = video_id;
	update_VidLocker_element_object(object);
};
// update youtube video autoplay
var update_element_object_youtube_video_autoplay = function(el_id, autoplay)
{
	var object = get_VidLocker_element_object(el_id);
	object.autoplay = autoplay;
	update_VidLocker_element_object(object);
};
// update countdown finish
var update_element_object_countdown_finish = function(el_id, color)
{
	var object = get_VidLocker_element_object(el_id);
	object.finish = color;
	update_VidLocker_element_object(object);
};
// update countdown color
var update_element_object_countdown_color = function(el_id, color)
{
	var object = get_VidLocker_element_object(el_id);
	object.color = color;
	update_VidLocker_element_object(object);
};
// update countdown font size
var update_element_object_countdown_fontsize = function(el_id, font)
{
	var object = get_VidLocker_element_object(el_id);
	object.font = font;
	update_VidLocker_element_object(object);
};
// update html code code
var update_element_object_html_code = function(el_id, html_code)
{
	var object = get_VidLocker_element_object(el_id);
	object.html_code = html_code;
	update_VidLocker_element_object(object);
};

/**
 * wysiwyg
 */
var doEditor = function(el_id)
{
	jQuery(el_id).wysiwyg({
        classes: 'some-more-classes',
        toolbar: 'selection',
        buttons: {
            /* insertlink: {
                title: 'Insert link',
                image: '\uf08e' // <img src="path/to/image.png" width="16" height="16" alt="" />
            }, */
            // Fontname plugin
            fontname: {
                title: 'Font',
                image: '\uf031', // <img src="path/to/image.png" width="16" height="16" alt="" />
                popup: function( $popup, $button ) {
                        var list_fontnames = {
                                // Name : Font
                                'Arial, Helvetica' : 'Arial,Helvetica',
                                'Verdana'          : 'Verdana,Geneva',
                                'Georgia'          : 'Georgia',
                                'Courier New'      : 'Courier New,Courier',
                                'Times New Roman'  : 'Times New Roman,Times'
                            };
                        var $list = jQuery('<div/>').addClass('wysiwyg-plugin-list')
                                               .attr('unselectable','on');
                        jQuery.each( list_fontnames, function( name, font ) {
                            var $link = jQuery('<a/>').attr('href','#')
                                                .css( 'font-family', font )
                                                .html( name )
                                                .click(function(event) {
                                                    jQuery(el_id).wysiwyg('shell').fontName(font).closePopup();
                                                    // prevent link-href-#
                                                    event.stopPropagation();
                                                    event.preventDefault();
                                                    return false;
                                                });
                            $list.append( $link );
                        });
                        $popup.append( $list );
                       },
                //showstatic: true,    // wanted on the toolbar
                showselection: 1    // wanted on selection
            },
            // Fontsize plugin
            fontsize: {
                title: 'Size',
                image: '\uf034', // <img src="path/to/image.png" width="16" height="16" alt="" />
                popup: function( $popup, $button ) {
                        // Hack: http://stackoverflow.com/questions/5868295/document-execcommand-fontsize-in-pixels/5870603#5870603
                        var list_fontsizes = [];
                        for( var i=8; i <= 11; ++i )
                            list_fontsizes.push(i+'px');
                        for( var i=12; i <= 28; i+=2 )
                            list_fontsizes.push(i+'px');
                        list_fontsizes.push('36px');
                        list_fontsizes.push('48px');
                        list_fontsizes.push('72px');
                        var $list = jQuery('<div/>').addClass('wysiwyg-plugin-list')
                                               .attr('unselectable','on');
                        jQuery.each( list_fontsizes, function( index, size ) {
                            var $link = jQuery('<a/>').attr('href','#')
                                                .html( size )
                                                .click(function(event) {
                                                    jQuery(el_id).wysiwyg('shell').fontSize(7).closePopup();
                                                    jQuery(el_id).wysiwyg('container')
                                                            .find('font[size=7]')
                                                            .removeAttr("size")
                                                            .css("font-size", size);
                                                    // prevent link-href-#
                                                    event.stopPropagation();
                                                    event.preventDefault();
                                                    return false;
                                                });
                            $list.append( $link );
                        });
                        $popup.append( $list );
                       }
            },
            bold: {
                title: 'Bold (Ctrl+B)',
                image: '\uf032', // <img src="path/to/image.png" width="16" height="16" alt="" />
                hotkey: 'b'
            },
            italic: {
                title: 'Italic (Ctrl+I)',
                image: '\uf033', // <img src="path/to/image.png" width="16" height="16" alt="" />
                hotkey: 'i'
            },
            underline: {
                title: 'Underline (Ctrl+U)',
                image: '\uf0cd', // <img src="path/to/image.png" width="16" height="16" alt="" />
                hotkey: 'u'
            },
            strikethrough: {
                title: 'Strikethrough (Ctrl+S)',
                image: '\uf0cc', // <img src="path/to/image.png" width="16" height="16" alt="" />
                hotkey: 's'
            },
            forecolor: {
                title: 'Text color',
                image: '\uf1fc' // <img src="path/to/image.png" width="16" height="16" alt="" />
            },
            highlight: {
                title: 'Background color',
                image: '\uf043' // <img src="path/to/image.png" width="16" height="16" alt="" />
            },
            alignleft: {
                title: 'Left',
                image: '\uf036' // <img src="path/to/image.png" width="16" height="16" alt="" />
            },
            aligncenter: {
                title: 'Center',
                image: '\uf037' // <img src="path/to/image.png" width="16" height="16" alt="" />
            },
            alignright: {
                title: 'Right',
                image: '\uf038' // <img src="path/to/image.png" width="16" height="16" alt="" />
            },
            alignjustify: {
                title: 'Justify',
                image: '\uf039' // <img src="path/to/image.png" width="16" height="16" alt="" />
            },
            removeformat: {
                title: 'Remove format',
                image: '\uf12d' // <img src="path/to/image.png" width="16" height="16" alt="" />
            }
        },
        placeholderUrl: 'http://www.example.com'
    });
};

/**
 * document ready :)
 */
// disable browser dragging
jQuery(document).on('dragstart', function(event) { event.preventDefault(); });
// fix pop container position on window scrolling or resizing
jQuery(window).on('resize scroll', function(event) {
	fix_pop_container_position();
});
// editor on paste
/*jQuery(document).on('paste', '.wysiwyg-editor', function () {
  var element = this;
  setTimeout(function () {
    var text = jQuery(element).html();
    console.log(text);
  }, 100);
});*/
// document ready
(function($){
	$(document).ready(function() {
		// custom scroll bar
		$('.VidLocker-options').mCustomScrollbar({
		    theme:"my-theme"
		});

		// textrea auto height
		$('textarea.textarea-auto-height').elastic();
		$('textarea.textarea-auto-height').trigger('update');

		// Drag n Drop styling
		$('#VidLocker-popup-builder-container').hover(
			function(){
				$(this).addClass('VidLocker-popup-builder-container-hover');
			},
			function(){
				$(this).removeClass('VidLocker-popup-builder-container-hover');
			}
		);

		// filter inputs from numbers
		// http://stackoverflow.com/a/469362
		$(".VidLocker-numbers-only").keydown(function (e) {
	        if ($.inArray(e.keyCode, [46, 8, 9, 27, 13, 110, 190]) !== -1 ||
	            (e.keyCode == 65 && e.ctrlKey === true) ||
	            (e.keyCode == 67 && e.ctrlKey === true) ||
	            (e.keyCode == 88 && e.ctrlKey === true) ||
	            (e.keyCode >= 35 && e.keyCode <= 39))
	        {
				return;
	        }
	        if ((e.keyCode < 48 || e.keyCode > 57) && (e.keyCode < 96 || e.keyCode > 105))
	        {
	            e.preventDefault();
	        }
	    });

		/**
		 * Popup options
		 */
		// show popup options
		$('.box-pop-settings').click(function(){
			$(this).blur();
			show_popup_options();
		});

		/**
		 * Save the pop
		 */
		$('.box-save-pop').click(function(){
			// blur wysiwyg editor if it's selected
			$('.wysiwyg-editor').blur();

			// htmlspecialchars
			for (i = 0; i < vidlock_elements.length; i++)
			{
				update_element_object_xy(vidlock_elements[i].id);
				update_element_object_width_height(vidlock_elements[i].id);

				if (vidlock_elements[i].type == 'text')
				{
					var html = $('#vidlock-element-' + vidlock_elements[i].id + ' .wysiwyg-editor').html();
	    			update_element_html(vidlock_elements[i].id, html);
					vidlock_elements[i].html = htmlspecialchars_js(vidlock_elements[i].html);
				}
				if (vidlock_elements[i].type == 'cta_button')
				{
					vidlock_elements[i].cta_text = htmlspecialchars_js(vidlock_elements[i].cta_text);
				}
				if (vidlock_elements[i].type == 'form_field')
				{
					vidlock_elements[i].placeholder = htmlspecialchars_js(vidlock_elements[i].placeholder);
				}
				if (vidlock_elements[i].type == 'html_code')
				{
					vidlock_elements[i].html_code = htmlspecialchars_js(vidlock_elements[i].html_code);
				}

			}

			// json encode pop settings and elements
			var pop_settings = JSON.stringify(vidlock_popup_settings);
			$('#save_pop_settings').val(pop_settings);
			var elements_json = JSON.stringify(vidlock_elements);
			$('#save_pop_objects').val(elements_json);

			// submit a save request
			window.onbeforeunload = null;
			$('#cpcpash_do_save').submit();
			// alert(pop_settings)
			// alert(elements_json)
		});

		/**
		 * Add new element
		 */
    	// text
    	$('#VidLocker-add-text').click(function(e){
    		e.preventDefault();
    		var el_text = {id: el_auto_inc_id, db_id: 0, x: 10*el_auto_inc_id, y: 10*el_auto_inc_id, width: 200, height: 40, zindex: vidlock_elements.length+1, type: 'text', background: '', html: 'Insert your Text/Headline Here!'};
    		vidlock_add_element_to_container(el_text, true);
    	});
    	// image
    	$('#VidLocker-add-image').click(function(e){
    		e.preventDefault();
    		var el_text = {id: el_auto_inc_id, db_id: 0, x: 10*el_auto_inc_id, y: 10*el_auto_inc_id, width: 128, height: 122, zindex: vidlock_elements.length+1, type: 'image', url: '', background: '', img_src: default_image_src};
    		vidlock_add_element_to_container(el_text, true);
    	});
    	// cta button
    	$('#VidLocker-add-cta-button').click(function(e){
    		e.preventDefault();
    		var el_cta_button = {id: el_auto_inc_id, db_id: 0, x: 10*el_auto_inc_id, y: 10*el_auto_inc_id, width: 200, height: 50, zindex: vidlock_elements.length+1, type: 'cta_button', action: 'link', url: '', background: '#1cb936', cta_text: 'Sign Up', color: '#ffffff', font_size: 14, font_weight: 'bold', border_size: 2, border_color: '#20732d', border_top_left_corner: 6, border_top_right_corner: 6, border_bottom_left_corner: 6, border_bottom_right_corner: 6};
    		vidlock_add_element_to_container(el_cta_button, true);
    	});
    	// form field
    	$('#VidLocker-add-form-field').click(function(e){
    		e.preventDefault();
    		// auto subscribe type
    		var placeholder_tmp = '';
    		if (vidlock_popup_settings.name_field_id == 0)
    		{
    			placeholder_tmp = 'Enter Your Name..';
    			vidlock_popup_settings.name_field_id = el_auto_inc_id;
    		}
    		else if (vidlock_popup_settings.email_field_id == 0)
    		{
    			placeholder_tmp = 'Enter Your Email..';
    			vidlock_popup_settings.email_field_id = el_auto_inc_id;
    		}
    		// create new form field
    		var el_form_field = {id: el_auto_inc_id, db_id: 0, x: 10*el_auto_inc_id, y: 10*el_auto_inc_id, width: 180, height: 40, zindex: vidlock_elements.length+1, type: 'form_field', background: '', placeholder: placeholder_tmp, color: '#666666', font_size: 14, border_size: 1, border_color: '#000000', border_top_left_corner: 0, border_top_right_corner: 0, border_bottom_left_corner: 0, border_bottom_right_corner: 0};
    		vidlock_add_element_to_container(el_form_field, true);
    	});
    	// youtube video
    	$('#VidLocker-add-youtube-video').click(function(e){
    		e.preventDefault();
    		var el_form_field = {id: el_auto_inc_id, db_id: 0, x: 10*el_auto_inc_id, y: 10*el_auto_inc_id, width: 250, height: 141, zindex: vidlock_elements.length+1, type: 'youtube_video', video_id: '', autoplay: 'yes'};
    		vidlock_add_element_to_container(el_form_field, true);
    	});
    	// html code
    	$('#VidLocker-add-html-code').click(function(e){
    		e.preventDefault();
    		var el_form_field = {id: el_auto_inc_id, db_id: 0, x: 10*el_auto_inc_id, y: 10*el_auto_inc_id, width: 200, height: 70, zindex: vidlock_elements.length+1, type: 'html_code', html_code: 'Insert a HTML code from here!'};
    		vidlock_add_element_to_container(el_form_field, true);
    	});
    	// countdown
    	$('#VidLocker-add-countdown').click(function(e){
    		e.preventDefault();
    		var el_form_field = {id: el_auto_inc_id, db_id: 0, x: 10*el_auto_inc_id, y: 10*el_auto_inc_id, width: 200, height: 70, zindex: vidlock_elements.length+1, type: 'countdown', color: 'black' ,font:28 ,finish:""};
    		vidlock_add_element_to_container(el_form_field, true);
    	});

	
		/**
		 * Drag n resize functions
		 */
	    var updatePosition = function(e, el_id) {
	        var pos = getMousePosition(e);
	        var el_current = $('#vidlock-element-' + el_id);
	        var container_pos = get_vidlock_container_pos();
	        var new_y = pos.y - vidlock_dy;
	        var new_x = pos.x - vidlock_dx;

	        var vidlock_el = get_VidLocker_element_object(el_id);
	        update_VidLocker_element_details(vidlock_el.type, get_VidLocker_element_details(el_id));

	        el_current.offset({top: new_y, left: new_x});
	    };
	    var its_first = true;
		var updateSize = function(e, el_id, resize_from) {
	        var pos = getMousePosition(e);
	        var el_current = $('#vidlock-element-' + el_id);
	        var vidlock_el = get_VidLocker_element_object(el_id);
	        update_VidLocker_element_details(vidlock_el.type, get_VidLocker_element_details(el_id));
	        if (resize_from == 'top')
	        {
	        	/* var el_top = el_current.offset().top;
	        	if (el_top > pos.y)
	        	{
	        		pos.y += Math.abs(pos.y - vidlock_ty);
	        	}
	        	else if (el_top < pos.y)
	        	{
	        		pos.y -= Math.abs(pos.y - vidlock_ty);;
	        	} */
	        	el_current.offset({top: pos.y});
	        	el_current.css({height: vidlock_ty - pos.y + vidlock_el_previous_height});
	        }
	        if (resize_from == 'bottom')
	        {
	        	el_current.css({height: (pos.y - vidlock_ty) + vidlock_el_previous_height});
	        }
	        if (resize_from == 'right')
	        {
	        	el_current.css({width: (pos.x - vidlock_tx) + vidlock_el_previous_width});
	        }
	        if (resize_from == 'left')
	        {
	        	el_current.offset({left: pos.x});
	        	el_current.css({width:  vidlock_tx - pos.x + vidlock_el_previous_width});
	        }
	    };

		/**
		 * VidLocker all options - on click
		 */
	    // top it
	    $('.VidLocker-topit-btn').click(function(){
	    	VidLocker_topit(selected_el_id);
	    });
	    // delete it
	    $('.VidLocker-deleteit-btn').click(function(){
	    	VidLocker_deleteit(selected_el_id);
	    });
	    // deselect it
	    $('.VidLocker-deselectit-btn').click(function(){
	    	VidLocker_deselectit(selected_el_id);
	    });

		/**
		 * VidLocker element options
		 */
	    // change pop width
	    $('#VidLocker-popup-width').blur(function(){
	    	var width = $(this).val();
	    	vidlock_popup_settings.width = width;
	    	$('#VidLocker-popup-builder-container').css('width', width + 'px');
	    	fix_pop_container_position();
	    });
	    // change pop height
	    $('#VidLocker-popup-height').blur(function(){
	    	var height = $(this).val();
	    	vidlock_popup_settings.height = height;
	    	$('#VidLocker-popup-builder-container').css('height', height + 'px');
	    	fix_pop_container_position();
	    });
	    // change pop border size
	    $('#VidLocker-popup-border-size').blur(function(){
	    	var border_size = $(this).val();
	    	vidlock_popup_settings.border_size = border_size;
	    	$('#VidLocker-popup-builder-container').css('border-width', border_size);
	    });
	    // change pop border color
		$('#cpcpbc-colorpicker').ColorPicker({
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function (colpkr, xt) {
				var border_color = $('#VidLocker-popup-border-color').val();
				vidlock_popup_settings.border_color = border_color;
				$(colpkr).fadeOut(500);
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				$('#cpcpbc-colorpicker div').css('backgroundColor', '#' + hex);
				$('#VidLocker-popup-border-color').val('#' + hex);
				$('#VidLocker-popup-builder-container').css('border-color', '#' + hex);
			}
		});
		// change popup border style
		$('#VidLocker-popup-border-style').change(function(){
			var border_style = $(this).find('option:selected').val();
			vidlock_popup_settings.border_style = border_style;
			// console.log(border_style)
			$('#VidLocker-popup-builder-container').css('border-style', border_style);
		});
	    // change pop background color
		$('#cpcpb-colorpicker').ColorPicker({
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function (colpkr, xt) {
				var background = $('#VidLocker-popup-background').val();
				vidlock_popup_settings.background = background;
				$(colpkr).fadeOut(500);
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				if ($('#VidLocker-popup-background-transparent').is(":checked"))
				{
					$('#VidLocker-popup-background-transparent').attr('checked', false);
				}
				$('#cpcpb-colorpicker div').css('backgroundColor', '#' + hex);
				$('#VidLocker-popup-background').val('#' + hex);
				$('#VidLocker-popup-builder-container').css('backgroundColor', '#' + hex);
			}
		});
		// change pop background to transparent
	    $('#VidLocker-popup-background-transparent').change(function() {
	        if($(this).is(":checked"))
	        {
	        	vidlock_popup_settings.background = '';
	        	$('#VidLocker-popup-builder-container').css('backgroundColor', ''); // clear background
	        	$('#cpctb-colorpicker div').css('backgroundColor', '');
	        	$('#VidLocker-popup-background').val('');
	        }
	    });
	    // change pop background img
	    var last_pop_bg_image_url = '';
	    $('#VidLocker-popup-bg-image-url').focus(function(){
	    	last_pop_bg_image_url = $(this).val();
	    });
	    $('#VidLocker-popup-bg-image-url').blur(function(){
	    	var img_src = $(this).val();
	    	if (is_valid_url(img_src))
	    	{
	    		vidlock_popup_settings.background_url = img_src;
	    		$('#VidLocker-popup-builder-container').css('background-image', 'url("' + img_src + '")');
	    	}
	    	else
	    	{
	    		$(this).val(last_pop_bg_image_url);
	    		alert('not valid');
	    	}
	    });
	    // change popup border radius
	    $('#VidLocker-popup-border-top-left').blur(function(){
	    	var border_tlc = $(this).val();
	    	vidlock_popup_settings.border_top_left_corner = border_tlc;
	    	var border_radius_object = {'-moz-border-radius-topleft': border_tlc + 'px', '-webkit-border-top-left-radius': border_tlc + 'px', 'border-top-left-radius': border_tlc + 'px'};
	    	$('#VidLocker-popup-builder-container').css(border_radius_object);
	    });
	    $('#VidLocker-popup-border-top-right').blur(function(){
	    	var border_trc = $(this).val();
	    	vidlock_popup_settings.border_top_right_corner = border_trc;
	    	var border_radius_object = {'-moz-border-radius-topright': border_trc + 'px', '-webkit-border-top-right-radius': border_trc + 'px', 'border-top-right-radius': border_trc + 'px'};
	    	$('#VidLocker-popup-builder-container').css(border_radius_object);
	    });
	    $('#VidLocker-popup-border-bottom-left').blur(function(){
	    	var border_blc = $(this).val();
	    	vidlock_popup_settings.border_bottom_left_corner = border_blc;
	    	var border_radius_object = {'-moz-border-radius-bottomleft': border_blc + 'px', '-webkit-border-bottom-left-radius': border_blc + 'px', 'border-bottom-left-radius': border_blc + 'px'};
	    	$('#VidLocker-popup-builder-container').css(border_radius_object);
	    });
	    $('#VidLocker-popup-border-bottom-right').blur(function(){
	    	var border_brc = $(this).val();
	    	vidlock_popup_settings.border_bottom_right_corner = border_brc;
	    	var border_radius_object = {'-moz-border-radius-bottomright': border_brc + 'px', '-webkit-border-bottom-right-radius': border_brc + 'px', 'border-bottom-right-radius': border_brc + 'px'};
	    	$('#VidLocker-popup-builder-container').css(border_radius_object);
	    });
	    // change text background to color
		$('#cpctb-colorpicker').ColorPicker({
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function (colpkr, xt) {
				var background = $('#VidLocker-text-background').val();
				update_element_object_background(selected_el_id, background);
				$(colpkr).fadeOut(500);
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				if ($('#VidLocker-text-background-transparent').is(":checked"))
				{
					$('#VidLocker-text-background-transparent').attr('checked', false);
				}
				$('#cpctb-colorpicker div').css('backgroundColor', '#' + hex);
				$('#VidLocker-text-background').val('#' + hex);
				$('#vidlock-element-' + selected_el_id).css('backgroundColor', '#' + hex);
			}
		});
		// change text background to transparent
	    $('#VidLocker-text-background-transparent').change(function() {
	        if($(this).is(":checked"))
	        {
	        	update_element_object_background(selected_el_id, '');
	        	$('#vidlock-element-' + selected_el_id).css('backgroundColor', '');
	        	$('#cpctb-colorpicker div').css('backgroundColor', '');
	        	$('#VidLocker-text-background').val('');
	        }
	    });
	    // change text object html value
	    $(document).on('blur', '.wysiwyg-editor', function(){
	    	if (selected_el_id)
	    	{
	    		var html = $('#vidlock-element-' + selected_el_id + ' .wysiwyg-editor').html();
	    		update_element_html(selected_el_id, html);
	    	}
	    });
	    // change image img src
	    var last_img_src = '';
	    $('#VidLocker-image-img-url').focus(function(){
	    	last_img_src = $(this).val();
	    });
	    $('#VidLocker-image-img-url').blur(function(){
	    	var img_src = $(this).val();
	    	if (is_valid_url(img_src))
	    	{
	    		update_element_object_img_src(selected_el_id, img_src);
	    		$('#vidlock-element-' + selected_el_id + ' img').attr('src', img_src);
	    	}
	    	else
	    	{
	    		$(this).val(last_img_src);
	    		alert('not valid');
	    	}
	    });
	    // change image img url
	    var last_img_url = '';
	    $('#VidLocker-image-url').focus(function(){
	    	last_img_url = $(this).val();
	    });
	    $('#VidLocker-image-url').blur(function(){
	    	var img_url = $(this).val();
	    	if (img_url == "")
	    	{
	    		update_element_object_img_url(selected_el_id, "");
	    	}
	    	else if (is_valid_url(img_url))
	    	{
	    		update_element_object_img_url(selected_el_id, img_url);
	    	}
	    	else
	    	{
	    		$(this).val(last_img_url);
	    		alert('URL is not valid!');
	    	}
	    });
	    // change form field - is name or email
	    $('#VidLocker-form-field-subscribe-type').change(function(){
	    	var subscribe_type = $(this).find('option:selected').val();
	    	if (subscribe_type == 'name')
	    	{
				if (vidlock_popup_settings.email_field_id != 0 && vidlock_popup_settings.email_field_id == selected_el_id)
				{
					vidlock_popup_settings.email_field_id = vidlock_popup_settings.name_field_id;
				}
				// change field type to name
				vidlock_popup_settings.name_field_id = selected_el_id;
	    	}
	    	if (subscribe_type == 'email')
	    	{
				if (vidlock_popup_settings.name_field_id != 0 && vidlock_popup_settings.name_field_id == selected_el_id)
				{
					vidlock_popup_settings.name_field_id = vidlock_popup_settings.email_field_id;
				}
				// change field type to email
				vidlock_popup_settings.email_field_id = selected_el_id;
	    	}
	    	console.log("Name field id: " + vidlock_popup_settings.name_field_id);
	    	console.log("Email field id: " + vidlock_popup_settings.email_field_id);
	    });
	    // change form field placeholder
	    $('#VidLocker-form-field-placeholder').blur(function(){
	    	var placeholder = $(this).val();
	    	update_element_object_placeholder(selected_el_id, placeholder);
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-field-container input').attr('placeholder', placeholder);
	    });
	    // change form field font size
	    $('#VidLocker-form-field-font-size').blur(function(){
	    	var font_size = $(this).val();
	    	update_element_object_font_size(selected_el_id, font_size);
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-field-container input').css('font-size', font_size + 'px');
	    });
	    // chagne form field color + color picker
		$('#cpcffc-colorpicker').ColorPicker({
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function (colpkr, xt) {
				var text_color = $('#VidLocker-form-field-color').val();
				update_element_object_color(selected_el_id, text_color);
				$(colpkr).fadeOut(500);
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				$('#cpcffc-colorpicker div').css('backgroundColor', '#' + hex);
				$('#VidLocker-form-field-color').val('#' + hex);
				$('#vidlock-element-' + selected_el_id + ' .vidlock-element-field-container input').css('color', '#' + hex);
			}
		});
	    // change form field border size
	    $('#VidLocker-form-field-border-size').blur(function(){
	    	var border_size = $(this).val();
	    	update_element_object_border_size(selected_el_id, border_size);
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-field-container').css('border-width', border_size);
	    });
	    // chagne form field border color + color picker
		$('#cpcffbc-colorpicker').ColorPicker({
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function (colpkr, xt) {
				var border_color = $('#VidLocker-form-field-border-color').val();
				update_element_object_border_color(selected_el_id, border_color);
				$(colpkr).fadeOut(500);
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				$('#cpcffbc-colorpicker div').css('backgroundColor', '#' + hex);
				$('#VidLocker-form-field-border-color').val('#' + hex);
				$('#vidlock-element-' + selected_el_id + ' .vidlock-element-field-container').css('border-color', '#' + hex);
			}
		});
	    // change form field border radius
	    $('#VidLocker-form-field-border-top-left').blur(function(){
	    	var border_tlc = $(this).val();
	    	update_element_object_border_tlc(selected_el_id, border_tlc);
	    	var border_radius_object = {'-moz-border-radius-topleft': border_tlc + 'px', '-webkit-border-top-left-radius': border_tlc + 'px', 'border-top-left-radius': border_tlc + 'px'};
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-field-container').css(border_radius_object);
	    });
	    $('#VidLocker-form-field-border-top-right').blur(function(){
	    	var border_trc = $(this).val();
	    	update_element_object_border_trc(selected_el_id, border_trc);
	    	var border_radius_object = {'-moz-border-radius-topright': border_trc + 'px', '-webkit-border-top-right-radius': border_trc + 'px', 'border-top-right-radius': border_trc + 'px'};
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-field-container').css(border_radius_object);
	    });
	    $('#VidLocker-form-field-border-bottom-left').blur(function(){
	    	var border_blc = $(this).val();
	    	update_element_object_border_blc(selected_el_id, border_blc);
	    	var border_radius_object = {'-moz-border-radius-bottomleft': border_blc + 'px', '-webkit-border-bottom-left-radius': border_blc + 'px', 'border-bottom-left-radius': border_blc + 'px'};
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-field-container').css(border_radius_object);
	    });
	    $('#VidLocker-form-field-border-bottom-right').blur(function(){
	    	var border_brc = $(this).val();
	    	update_element_object_border_brc(selected_el_id, border_brc);
	    	var border_radius_object = {'-moz-border-radius-bottomright': border_brc + 'px', '-webkit-border-bottom-right-radius': border_brc + 'px', 'border-bottom-right-radius': border_brc + 'px'};
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-field-container').css(border_radius_object);
	    });
	    // change cta button action
	    $('#VidLocker-cta-button-action').change(function(){
	    	var action = $(this).val();
	    	update_element_object_cta_action(selected_el_id, action);
			jQuery('#VidLocker-cta-button-url').parent().parent().hide();
			if (action == 'link')
			{
				jQuery('#VidLocker-cta-button-url').parent().parent().slideDown();
			}
	    });
	    // change cta button url
	    var last_cta_button_url = '';
	    $('#VidLocker-cta-button-url').focus(function(){
	    	last_cta_button_url = $(this).val();
	    });
	    $('#VidLocker-cta-button-url').blur(function(){
	    	var url = $(this).val();
	    	if (url == "")
	    	{
	    		update_element_object_cta_url(selected_el_id, "");
	    	}
	    	else if (is_valid_url(url))
	    	{
	    		update_element_object_cta_url(selected_el_id, url);
	    	}
	    	else
	    	{
	    		$(this).val(last_cta_button_url);
	    		alert('URL is not valid!');
	    	}
	    });
	    // change cta button font weight
	    $('#VidLocker-cta-button-font-weight').change(function(){
	    	var font_weight = $(this).val();
	    	update_element_object_font_weight(selected_el_id, font_weight);
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css('font-weight', font_weight);
	    });
	    // change cta button text
	    $('#VidLocker-cta-button-text').blur(function(){
	    	var cta_text = $(this).val();
	    	update_element_object_text(selected_el_id, cta_text);
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button td').text(cta_text);
	    });
	    // change cta button font size
	    $('#VidLocker-cta-button-font-size').blur(function(){
	    	var font_size = $(this).val();
	    	update_element_object_font_size(selected_el_id, font_size);
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css('font-size', font_size + 'pt');
	    });
	    // change cta button border size
	    $('#VidLocker-cta-button-border-size').blur(function(){
	    	var border_size = $(this).val();
	    	update_element_object_border_size(selected_el_id, border_size);
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css('border-width', border_size);
	    });
	    // chagne cta button color + color picker
		$('#cpccbc-colorpicker').ColorPicker({
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function (colpkr, xt) {
				var border_color = $('#VidLocker-cta-button-color').val();
				update_element_object_color(selected_el_id, border_color);
				$(colpkr).fadeOut(500);
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				$('#cpccbc-colorpicker div').css('backgroundColor', '#' + hex);
				$('#VidLocker-cta-button-color').val('#' + hex);
				$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css('color', '#' + hex);
			}
		});
	    // chagne cta button background color + color picker
		$('#cpccbb-colorpicker').ColorPicker({
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function (colpkr, xt) {
				var background = $('#VidLocker-cta-button-background-color').val();
				update_element_object_background(selected_el_id, background);
				$(colpkr).fadeOut(500);
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				$('#cpccbb-colorpicker div').css('backgroundColor', '#' + hex);
				$('#VidLocker-cta-button-background-color').val('#' + hex);
				$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css('backgroundColor', '#' + hex);
			}
		});
	    // chagne cta button border color + color picker
		$('#cpccbbc-colorpicker').ColorPicker({
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function (colpkr, xt) {
				var border_color = $('#VidLocker-cta-button-border-color').val();
				update_element_object_border_color(selected_el_id, border_color);
				$(colpkr).fadeOut(500);
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				$('#cpccbbc-colorpicker div').css('backgroundColor', '#' + hex);
				$('#VidLocker-cta-button-border-color').val('#' + hex);
				$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css('border-color', '#' + hex);
			}
		});
	    // change cta button border radius
	    $('#VidLocker-cta-button-border-top-left').blur(function(){
	    	var border_tlc = $(this).val();
	    	update_element_object_border_tlc(selected_el_id, border_tlc);
	    	var border_radius_object = {'-moz-border-radius-topleft': border_tlc + 'px', '-webkit-border-top-left-radius': border_tlc + 'px', 'border-top-left-radius': border_tlc + 'px'};
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css(border_radius_object);
	    });
	    $('#VidLocker-cta-button-border-top-right').blur(function(){
	    	var border_trc = $(this).val();
	    	update_element_object_border_trc(selected_el_id, border_trc);
	    	var border_radius_object = {'-moz-border-radius-topright': border_trc + 'px', '-webkit-border-top-right-radius': border_trc + 'px', 'border-top-right-radius': border_trc + 'px'};
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css(border_radius_object);
	    });
	    $('#VidLocker-cta-button-border-bottom-left').blur(function(){
	    	var border_blc = $(this).val();
	    	update_element_object_border_blc(selected_el_id, border_blc);
	    	var border_radius_object = {'-moz-border-radius-bottomleft': border_blc + 'px', '-webkit-border-bottom-left-radius': border_blc + 'px', 'border-bottom-left-radius': border_blc + 'px'};
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css(border_radius_object);
	    });
	    $('#VidLocker-cta-button-border-bottom-right').blur(function(){
	    	var border_brc = $(this).val();
	    	update_element_object_border_brc(selected_el_id, border_brc);
	    	var border_radius_object = {'-moz-border-radius-bottomright': border_brc + 'px', '-webkit-border-bottom-right-radius': border_brc + 'px', 'border-bottom-right-radius': border_brc + 'px'};
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-cta-button').css(border_radius_object);
	    });
	    // change youtube video url
	    var youtube_video_url_previous;
	    $('#VidLocker-youtube-video-url').focus(function(){
	    	youtube_video_url_previous = $(this).val();
	    });
	    $('#VidLocker-youtube-video-url').blur(function(){
	    	var youtube_video_url = $(this).val();
	    	if (is_valid_url(youtube_video_url))
	    	{
	    		var youtube_video_id = YouTubeGetID(youtube_video_url);
	    		if (youtube_video_id == '')
	    		{
		    		update_element_object_youtube_video_id(selected_el_id, '');
		    		$('#vidlock-element-' + selected_el_id + ' .vidlock-element-youtube-thumbnail').attr('src', default_youtube_video_thumbnail);
	    		}
	    		else
	    		{
		    		update_element_object_youtube_video_id(selected_el_id, youtube_video_id);
		    		$('#vidlock-element-' + selected_el_id + ' .vidlock-element-youtube-thumbnail').attr('src', 'http://img.youtube.com/vi/' + youtube_video_id + '/mqdefault.jpg');
	    		}
	    	}
	    	else
	    	{
	    		$(this).val(youtube_video_url_previous);
	    		alert('Youtube Url is not valid!');
	    	}
	    });
	    // change youtube video autoplay
	    $('#VidLocker-youtube-video-autoplay').change(function(){
	    	var autoplay = $(this).val();
	    	update_element_object_youtube_video_autoplay(selected_el_id, autoplay);
	    });
	    // change countdown color
	    $('#VidLocker-countdown-finish').change(function(){
	    	var color = $(this).val();
	    	update_element_object_countdown_finish(selected_el_id, color);
	    });
	    // change countdown color
	    $('#VidLocker-countdown-color').change(function(){
	    	var color = $(this).val();
	    	update_element_object_countdown_color(selected_el_id, color);
	    });
	    // change countdown color
	    $('#VidLocker-countdown-font').blur(function(){
	    	var font = $(this).val();
	    	update_element_object_countdown_fontsize(selected_el_id, font);
	    });
	    // change html code code
	    $('#VidLocker-html-code-code').blur(function(){
	    	var html_code = $(this).val();
	    	update_element_object_html_code(selected_el_id, html_code);
	    	$('#vidlock-element-' + selected_el_id + ' .vidlock-element-content .html_code').html(html_code);
	    });

	    // # Inputs Counter
	    var counter_handler_clicked = false;
	    var counter_interval;
	    $('.VidLocker-box .VidLocker-input-counter div').mousedown(function(){
	    	counter_handler_clicked = true;
	    	if (counter_handler_clicked)
	    	{
	    		var counter_handler = $(this);
		    	var is_up = counter_handler.hasClass('up');
		    	var is_down = counter_handler.hasClass('down');
		    	if (is_up || is_down)
		    	{
		    		var counter_parent = counter_handler.parent();
		    		var input_to_counter = counter_parent.find('.input-container input');
		    		var val = parseInt(input_to_counter.val());
		    		var do_counter = function()
		    		{
			    		if (is_up)
			    		{
			    			val++;
			    		}
			    		else
			    		{
			    			val--;
			    		}
			    		input_to_counter.val(val).blur();
			    	};
			    	do_counter();
		    		counter_interval = setInterval(do_counter, 200);
		    	}
		    }
	    });
	    $(document).mouseup(function(){
	    	counter_handler_clicked = false;
	    	clearInterval(counter_interval);
	    });

		// blur form fields
		/* $(document).on('focus', '.vidlock-element-field-container', function(){
			// console.log('focussssssss')
			$(this).blur();
		}); */

		// deselect elements when click on the container
		/*$('#VidLocker-popup-builder-container').click(function(e){
			if (e.target == this)
			{
				VidLocker_deselectit(selected_el_id);
			}
		});*/

		// select element to drag n resize
		$(document).on('click', '.vidlock-drag-resize-item', function(){
			var el = $(this);
			select_element(el, true);
		});

		// change border color when mouse move
		var last_left_element_id = 0;
		$(document).on('mouseover', '.vidlock-element-content', function(){
			var el = $(this);
			var el_id = vidlock_get_id($(this).parent().attr('id'));
			if (selected_el_id == el_id)
			{
				// console.log('Element #' + el_id + ' is selected so there is no reason to change its border color.');
				return;
			}
			last_left_element_id = el_id;
			// fix_element_position_onselect_onmove(el);
			el.addClass('vidlock-mousemove');
			// console.log('Element #' + el_id + ' border color changed.');
		});
		$(document).on('mouseout', '.vidlock-element-content', function(){
			var el = $(this);
			// fix_element_position_ondeselect_onmouseleave(el);
			$('.vidlock-element-content').removeClass('vidlock-mousemove');
			last_left_element_id = 0;
		});

		// stop drag n resize
		$(document).on('mouseup', function(e){
			if (isDragMode)
			{
				update_element_object_xy(selected_el_id);
			}
			if (isResizeMode)
			{
				update_element_object_width_height(selected_el_id);
			}
			isDragMode = isResizeMode = false;
			// console.log('stop drag n resize');
		});

		// drag n drop code :)
		// dragging
		$(document).on('mousemove', function(e){
            if(isDragMode)
            {
				if (selected_el_id == null)
				{
					// console.log('# Error, no element is selected to drag!');
					return false;
				}
                updatePosition(e, selected_el_id);
                // console.log('draaagging');
                return false;
            }
        });

        // detect dragging
        $(document).on('mousedown', '.vidlock-drag-resize-item .vidlock-drag-handle', function(e){
			e.stopPropagation();
			e.preventDefault();
			isDragMode = true;
            var pos = getMousePosition(e);
            var el_offset = $('#vidlock-element-' + selected_el_id).offset();
			vidlock_dx = e.pageX-el_offset.left;
			vidlock_dy = e.pageY-el_offset.top;
			updatePosition(e, selected_el_id);
			// console.log('start draaag');
		});

		// resize code :)
		// resizing
        $(document).on('mousemove', function(e){
            if(isResizeMode)
            {
                updateSize(e, selected_el_id, resize_from);
                // console.log('resizing');
            }
        });
		
        // detect resizing
        $(document).on('mousedown', '.vidlock-drag-resize-item .vidlock-resize-handle', function(e){
			e.stopPropagation();
			e.preventDefault();
			isResizeMode = true;

			var pos = getMousePosition(e);
			if ($(this).hasClass('vidlock-resize-handle-top'))
			{
				resize_from = 'top';
				vidlock_tx = $('#vidlock-element-' + selected_el_id).offset().left;
				vidlock_ty = $('#vidlock-element-' + selected_el_id).offset().top;
			}
			else if ($(this).hasClass('vidlock-resize-handle-right'))
			{
				resize_from = 'right';
				vidlock_tx = pos.x;
				vidlock_ty = pos.y;
			}
			else if ($(this).hasClass('vidlock-resize-handle-bottom'))
			{
				resize_from = 'bottom';
				vidlock_tx = pos.x;
				vidlock_ty = pos.y;
			}
			else if ($(this).hasClass('vidlock-resize-handle-left'))
			{
				resize_from = 'left';
				vidlock_tx = $('#vidlock-element-' + selected_el_id).offset().left;
				vidlock_ty = $('#vidlock-element-' + selected_el_id).offset().top;
			}
			else
			{
				// console.log('# Error, no \'resize_from#\' value detected!');
				return false;
			}

            
			var el_current = $('#vidlock-element-' + selected_el_id);
			vidlock_el_previous_width = el_current.width();
			vidlock_el_previous_height = el_current.height();
			updateSize(e, selected_el_id, resize_from);
			// console.log('start resize from: ' + resize_from);
		});

		/**
		 * on page fully loaded
		 */
		// popup settings object - load settings from php
		/* vidlock_popup_settings = {name_field_id: 0, email_field_id: 0, width: 300, height: 250, background: '#ff0000', border_size: 3, border_color: '#00ff00', border_style: 'dashed', border_top_left_corner: 5, border_top_right_corner: 10, border_bottom_left_corner: 15, border_bottom_right_corner: 20}; */
		if (typeof VidLocker_pop_data !== 'undefined')
		{
			vidlock_popup_settings = VidLocker_pop_data;
			// apply popup settings to the container
			var popup_border_radius_object = {'-moz-border-radius-topleft': vidlock_popup_settings.border_top_left_corner + 'px', '-webkit-border-top-left-radius': vidlock_popup_settings.border_top_left_corner + 'px', 'border-top-left-radius': vidlock_popup_settings.border_top_left_corner + 'px', '-moz-border-radius-topright': vidlock_popup_settings.border_top_right_corner + 'px', '-webkit-border-top-right-radius': vidlock_popup_settings.border_top_right_corner + 'px', 'border-top-right-radius': vidlock_popup_settings.border_top_right_corner + 'px', '-moz-border-radius-bottomleft': vidlock_popup_settings.border_bottom_left_corner + 'px', '-webkit-border-bottom-left-radius': vidlock_popup_settings.border_bottom_left_corner + 'px', 'border-bottom-left-radius': vidlock_popup_settings.border_bottom_left_corner + 'px', '-moz-border-radius-bottomright': vidlock_popup_settings.border_bottom_right_corner + 'px', '-webkit-border-bottom-right-radius': vidlock_popup_settings.border_bottom_right_corner + 'px', 'border-bottom-right-radius': vidlock_popup_settings.border_bottom_right_corner + 'px'};
			$('#VidLocker-popup-builder-container').css({
				'width': window.width + 'px',
				'height': window.height + 'px',
				'backgroundColor': vidlock_popup_settings.background,
				'background-image': 'url("' + vidlock_popup_settings.background_url + '")',
				'border-width': vidlock_popup_settings.border_size,
				'border-color': vidlock_popup_settings.border_color,
				'border-style': vidlock_popup_settings.border_style
			});
			$('#VidLocker-popup-builder-container').css(popup_border_radius_object);
			// fix pop container position
			fix_pop_container_position();
		}
		show_popup_options(); // sho pop up option after updating pop details

		// add elements from db
		if (typeof VidLocker_db_elements !== 'undefined')
		{
			for (j = 0; j < VidLocker_db_elements.length; j++)
			{
				vidlock_add_element_to_container(VidLocker_db_elements[j]);
			}
		}
	});
})(jQuery);